/*------------------------------------------------------------------------------------------*\
 *   
 *   Copyright (C) 2006 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
\*------------------------------------------------------------------------------------------*/
#ifndef _avm_profile_h_
#define _avm_profile_h_

#if defined(CONFIG_AVM_MIPS_PROFILING)

struct _avm_profile_data {
    unsigned int addr;  /* obersten 3 bit geben die quelle an */
#define KERNEL_PERFOMANCE_USR_TRACE         0x00000000
#define KERNEL_PERFOMANCE_TRACE_SHARE       0x20000000
#define KERNEL_PERFOMANCE_TRACE_SKB         0x40000000
    /* pos maximal 4 Bit */
#define KERNEL_PERFOMANCE_TRACE_SKB_ID(pos) (KERNEL_PERFOMANCE_TRACE_SKB | (pos << (29 - 6)))
#define KERNEL_PERFOMANCE_TRACE_RESERVED1   0x60000000
#define KERNEL_PERFOMANCE_TRACE_KERNEL      0x80000000
#define KERNEL_PERFOMANCE_TRACE_VM          0xC0000000
#define KERNEL_PERFOMANCE_TRACE_RESERVED2   0xA0000000
#define KERNEL_PERFOMANCE_TRACE_RESERVED3   0xE0000000
    unsigned int time;
};

void ohio_simple_profiling_text(const  char *text);
void ohio_simple_profiling_log(unsigned int addr, unsigned int id);
void ohio_simple_profiling(struct pt_regs *regs);
struct _avm_profile_data *ohio_simple_profiling_enable(unsigned int on, unsigned int *count);

#else /*--- #if defined(CONFIG_AVM_MIPS_PROFILING) ---*/
#define ohio_simple_profiling_text(text)
#define ohio_simple_profiling_log(addr, id)
#define ohio_simple_profiling(regs)
#define ohio_simple_profiling_enable(on, count)     NULL;
#endif /*--- #else ---*/ /*--- #if defined(CONFIG_AVM_MIPS_PROFILING) ---*/

#endif /*--- #ifndef _avm_profile_h_ ---*/
