/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

/*******************************************************************************
 * FILE PURPOSE:    Environment variables header file.
 *******************************************************************************
 * FILE NAME:       env.h
 *
 * DESCRIPTION:     Environment variables header file.
 *
 ******************************************************************************/

#ifndef _ENV_H_
#define	_ENV_H_

#ifdef _STANDALONE
#include "sysconf.h"
#endif

int  EnvInit(void);
char *env_get_base(unsigned int *block_size);
int  sys_unsetenv(const char *);
int  sys_setenv(const char *, const char *);
char *sys_getenv(const char *);
void sh_printenv(void);
void init_env(void);
int sys_defragenv(void);
int sys_initenv(void);
char* sys_getienv(int var_num);
char* sys_getivar (int var_num);
int get_envstring(int index, char *buffer);

typedef struct t_env_var {
	char      var;
	char  *	  val;
}t_env_var;

#ifdef FTP_SERVER_SUPPORT
#ifndef ENV_SPACE_SIZE /* Should be defined by bootcfg.mak file */
#define ENV_SPACE_SIZE      (10 * 1024) 
#endif
#endif
#define AUTO_DEFRAG_ENVIRONMENT     TRUE

#endif /* _ENV_H_ */
