/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/


/** \file   pal.h
    \brief  Platform Include file

    This file includes all platform abstraction related headers.
    

    \author     PSP Architecture Team
    \version    1.0
 */

#ifndef _PAL_H_
#define _PAL_H_

#include "pformCfg.h"   /* Platform specific file - includes SOC specific header */
#include "pal_defs.h"   /* Platform definitions - basic types - includes "_tistdtypes.h" */
#include "csl_defs.h"   /* CSL definitions - basic types and macros */

#include "pal_os.h"     /* PAL OS interfaces file - includes selected OS abstraction headers */

#include "pal_sys.h"    /* Platform System Interfaces file */

#endif /* _PAL_H_ */
