/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

#ifndef _YAMUNA_BOARDS_H
#define _YAMUNA_BOARDS_H

#define REFCLK_FREQ                                24000000
/* CPMAC with low base address */
#define AVALANCHE_LOW_CPMAC_PHY_MASK               0x00000002
/* CPMAC with high base address*/
#define AVALANCHE_HIGH_CPMAC_PHY_MASK              0x00000004
#define VLYNQ0_RESET_GPIO_NUM                      0x7
#define MARVELL_PHY_OFFSET                         0x10
#define MARVELL_PORT_OFFSET                        0x18

#if defined(CONFIG_MIPS_UR8EVM)

#define AVALANCHE_LOW_CPMAC_HAS_EXT_SWITCH         1
#define AVALANCHE_HIGH_CPMAC_HAS_EXT_SWITCH        0

#endif

#if defined (CONFIG_MIPS_UR8_VOLCANO)

#define AVALANCHE_LOW_CPMAC_HAS_EXT_SWITCH         0
#define AVALANCHE_HIGH_CPMAC_HAS_EXT_SWITCH        0

#endif

/* Yamuna variants detection */
typedef enum {
        YAMUNA_VOLCANO = 0,
	YAMUNA_UR8EVM,
        MAX_BOARDS /* For count */
} BOARD_ID;

int avalanche_get_board_variant( void );

#define MAX_MODULES 8


#endif /* _YAMUNA_BOARDS_H */
