/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2006 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

/** \file   ddc_cpsarCfg.h
    \brief  DDC CPSAR Configuration header file

    This file has the static (compile time) configuration parameters for the
    CPSAR DDC driver.

    @author     Greg Guyotte
 */

#ifndef __DDC_CPSAR_CFG_H__
#define __DDC_CPSAR_CFG_H__

/* Config macros */
#define CPSAR_MAX_INSTANCES                     1       /**< Max CPSAR instances */
#define CPSAR_MAX_PACKET_LENGTH                 65568   /**< Max SAR packet length */

/* CPSAR hardware specific */
#define CPSAR_MAX_CHANNELS                      16      /**< Maximum number of CPSAR channels */
#define CPSAR_MAX_TX_CHANNELS                   CPSAR_MAX_CHANNELS    /**< Maximum TX Channels supported by the DDC */
#define CPSAR_MAX_RX_CHANNELS                   CPSAR_MAX_CHANNELS    /**< Maximum RX Channels supported by the DDC */

#endif /* __DDC_CPSAR_CFG_H__ */
