#ifndef _ZUGRIFF_H
#define _ZUGRIFF_H

#define SET_APPL_ID(msg,a) (*(unsigned short far *)((msg)+2) = (a))

#define EXTRACT_BYTE(x) (*((unsigned char  *)(x)))

static inline void SET_DWORD (void *Msg, unsigned long  w) {
    ((unsigned char *)Msg)[0] = ((unsigned char *)&w)[0];
    ((unsigned char *)Msg)[1] = ((unsigned char *)&w)[1];
    ((unsigned char *)Msg)[2] = ((unsigned char *)&w)[2];
    ((unsigned char *)Msg)[3] = ((unsigned char *)&w)[3];
}

static inline unsigned long EXTRACT_DWORD (void *Msg) {
    unsigned long w;
    ((unsigned char *)&w)[0] = ((unsigned char *)Msg)[0];
    ((unsigned char *)&w)[1] = ((unsigned char *)Msg)[1];
    ((unsigned char *)&w)[2] = ((unsigned char *)Msg)[2];
    ((unsigned char *)&w)[3] = ((unsigned char *)Msg)[3];
    return w;
}

static inline void SET_WORD (void * Msg, unsigned short w) {
    ((unsigned char *)Msg)[0] = ((unsigned char *)&w)[0];
    ((unsigned char *)Msg)[1] = ((unsigned char *)&w)[1];
}

static inline unsigned short EXTRACT_WORD (void *Msg) {
    unsigned long w;
    ((unsigned char *)&w)[0] = ((unsigned char *)Msg)[0];
    ((unsigned char *)&w)[1] = ((unsigned char *)Msg)[1];
    return (unsigned short)w;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *add_byte(unsigned char *p, unsigned char s) {
    *p++ = (unsigned char)(s);
    return p;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *add_word(unsigned char *p, unsigned short s) {
    *p++ = (unsigned char)(s);
    *p++ = (unsigned char)(s >> 8);
    return p;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *add_dword(unsigned char *p, unsigned long s) {
    *p++ = (unsigned char)(s);
    *p++ = (unsigned char)(s >> 8);
    *p++ = (unsigned char)(s >> 16);
    *p++ = (unsigned char)(s >> 24);
    return p;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *add_length(unsigned char *p, unsigned int len) {
    if(len >= 255) {
        *p++ = 0xFF;
        *p++ = (unsigned char)len;
        *p++ = (unsigned char)(len >> 8);
        return p;
    }
    *p++ = (unsigned char)len;
    return p;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *add_cstruct(unsigned char *p, unsigned char *Buffer, unsigned int len) {
    p = add_length(p, len);
    memcpy(p, Buffer, len);
    p += len;
    return p;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned int cstruct_length(unsigned int len) {
    if(len >= 255)
        return len + 3;
    return len + 1;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *extract_length(unsigned char *p, unsigned int *len) {
    if(*p == 0xFF) {
        p++;
        *len  = *p++;
        *len |= ((unsigned int)(*p++)) << 8;
        return p;
    }
    *len  = *p++;
    return p;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *extract_dword(unsigned char *p, unsigned long *value) {
    *value  = *p++;
    *value |= ((unsigned long)(*p++)) << 8;
    *value |= ((unsigned long)(*p++)) << 16;
    *value |= ((unsigned long)(*p++)) << 24;
    return p;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *extract_word(unsigned char *p, unsigned short *value) {
    *value  = *p++;
    *value |= ((unsigned short)(*p++)) << 8;
    return p;
}

/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
static inline unsigned char *extract_byte(unsigned char *p, unsigned char *value) {
    *value  = *p++;
    return p;
}
#endif /*--- #ifndef _ZUGRIFF_H ---*/
