/*---------------------------------------------------------------------------*\
 *   
 *   Copyright (C) 2006 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
\*---------------------------------------------------------------------------*/

#ifndef _ahcidriver_h_
#define _ahcidriver_h_

#include "ahcidef.h"

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/
struct ahci_endpoint {
	
	unsigned	last_adr;
	unsigned	last_frame;
	unsigned 	pending_tds;
	urb_t* 		cur_urb;
	
};

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/
struct ahci_struct {
	
	struct usb_bus *	bus;
	unsigned		rh_address;
	urb_t *			rh_urb;
	struct timer_list	rh_timer;
	
	spinlock_t		list_lock;
	struct list_head	completion_list;
	
	struct list_head control_pending_list;
	//TO DO:
	//struct list_head iso_pending_list;
	struct list_head int_pending_list;
	struct list_head bulk_pending_list;
	
	struct tasklet_struct	completion_tasklet;

};

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/

extern struct ahci_struct	ahci;
extern unsigned			AHCI_TotalMemSize;

#endif
