/*---------------------------------------------------------------------------*\
 *   
 *   Copyright (C) 2006 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
\*---------------------------------------------------------------------------*/

#if !defined (__ahciurb_h__)
#define __ahciurb_h__

#include "ahcidef.h"
#include "ahcidriver.h"

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/
struct ahci_urb_ext {
	wait_queue_head_t *	wait_head;
	int status;

	unsigned unlink_called;

	unsigned iso_done;

	unsigned alloc_pos;

	unsigned tds_allocated;
	unsigned td_count;
	unsigned td_done;

	AHCI_DESC_ADR td_adr[];
};

/*---------------------------------------------------------------------------*\
\*---------------------------------------------------------------------------*/
int ahci_submit_urb (urb_t * urb, unsigned mem_flags);
int ahci_unlink_urb (urb_t * urb, int status);

void ahci_endpoint_disable (struct usb_device *dev, struct usb_host_endpoint *ep);

/*---------------------------------------------------------------------------*\
	callback for Tasklet
\*---------------------------------------------------------------------------*/
void urb_completion_func (unsigned long data);

#endif

